<!DOCTYPE html>

<html lang="en">
  <head>
    <meta charset="utf-8" />

    <title>Application Form</title>
    <meta name="description" content="Kumbu Boutique Script" />
    <meta name="author" content="Endoto Labs" />
    <script
      src="https://code.jquery.com/jquery-3.5.1.min.js"
      integrity="sha256-9/aliU8dGd2tb6OSsuzixeV4y/faTqgFtohetphbbj0="
      crossorigin="anonymous"
    ></script>

    <script type="text/javascript">
      jQuery(() => {
        Kumbu.getClient()
          .fetchPosts()
          .then((posts) => {
            $('#offersSelect').html(
              posts
                .map(
                  (post) =>
                    `<option value=${post.campaignId}>${post.title}</option>`
                )
                .join('')
            )
          })

        Kumbu.bindContentBlock({
          container: '#postsList',
          name: 'posts_list',
          count: 5,
        })

        jQuery('#applyForm').submit((e) => {
          e.preventDefault()
          var $inputs = $('#applyForm :input')
          var values = {}
          $inputs.each(function () {
            values[this.name] = $(this).val()
          })

          const profilePayload = {
            firstName: values.candidate_firstname,
            lastName: values.candidate_lastname,
            email: values.candidate_email,
            displayName: `${values.candidate_firstname} ${(
              values.candidate_lastname || ''
            ).toUpperCase()}`,
            data: {
              availability: values.candidate_availability,
            },
          }

          const selectedFile = jQuery('[name=resume_attachement]')[0].files[0]

          if (
            !values.candidate_campaign_id ||
            !profilePayload.firstName ||
            !profilePayload.lastName ||
            !profilePayload.email ||
            !selectedFile
          ) {
            alert('Please fill in everything')
            return false
          }

          Kumbu.getClient()
            .requestApplicationUpload({
              campaignId: values.candidate_campaign_id,
              source: 'com',
              profile: profilePayload,
              contentType: selectedFile.type,
            })
            .then((payload) => {
              const data = new FormData()
              const headers = new Map()

              for (const [key, val] of Object.entries(payload.fields)) {
                data.append(key, val)
              }

              for (const [key, val] of Object.entries(profilePayload)) {
                headers.set(
                  `X-Amz-Meta-Profile-${key.toLowerCase()}`,
                  typeof val === 'object' ? JSON.stringify(val) : val.toString()
                )
              }

              data.append('Content-Type', selectedFile.type)

              data.append('file', selectedFile)

              return jQuery.ajax({
                type: 'POST',
                enctype: 'multipart/form-data',
                url: payload.url,
                data: data,
                headers: Object.fromEntries(headers),
                processData: false,
                contentType: false,
                cache: false,
                timeout: 600000,
              })
            })
            .then(() => {
              alert('success !')
            })
            .catch((err) => {
              alert('fail ... ' + err.message, err)
            })
        })
      })
    </script>

    <style type="text/css">
      body {
        margin: 3rem;
      }

      p {
        font-family: arial, serif;
        font-size: 1.3rem;
      }

      input,
      select,
      textarea,
      button {
        font-size: 1.3rem;
        margin: 1rem 0;
        width: 30vw;
      }
    </style>
  </head>

  <body>
    <code id="result"></code>
    <div id="postsList"></div>
    <form id="applyForm">
      <p>
        Candidater a une offre
      </p>
      <p>
        <em>Merci de renseigner tous les champs de ce formulaire</em>
      </p>
      <div class="row">
        <div class="col-md-6">
          <div class="form-group">
            <div class="controls">
              <select
                id="offersSelect"
                class="form-control"
                maxlength="200"
                name="candidate_campaign_id"
                placeholder="Nom de l'offre"
                type="text"
              />
            </div>
          </div>
        </div>
        <div class="col-md-6">
          <div class="form-group">
            <div class="controls">
              <input
                class="form-control"
                maxlength="200"
                name="candidate_lastname"
                placeholder="Nom"
                type="text"
              /><i
                style="display: none; top: 0px;"
                class="form-control-feedback"
              ></i>
            </div>
          </div>
        </div>
        <div class="col-md-6">
          <div class="form-group">
            <div class="controls">
              <input
                class="form-control"
                id="candidateFirstname"
                maxlength="200"
                name="candidate_firstname"
                placeholder="Prénom"
                type="text"
              /><i
                style="display: none; top: 0px;"
                class="form-control-feedback"
              ></i>
            </div>
          </div>
        </div>
      </div>
      <div class="clearfix"></div>
      <div class="form-group">
        <div class="controls">
          <select
            class="form-control"
            id="candidateAvailability"
            maxlength="2000"
            name="candidate_availability"
            placeholder="Disponibilité"
          >
            <option disabled="" selected="" value=""
              >Quelle est votre disponibilité ?</option
            >
            <option value="now">Immédiate</option>
            <option value="less_onemonth">Moins d'un mois</option>
            <option value="one_two_months">Entre 1 et 2 mois</option>
            <option value="two_three_months">Entre 2 et 3 mois</option>
            <option value="more_three_months">Plus de 3 mois</option>
          </select>
        </div>
        <small style="display: none;" class="help-block"
          >Merci d'indiquer une estimation de votre disponiblité</small
        ><small style="display: none;" class="help-block"
          >Please enter a value with valid length</small
        >
      </div>
      <div class="form-group">
        <div class="controls">
          <input
            class="form-control"
            id="candidateEmail"
            maxlength="2000"
            name="candidate_email"
            placeholder="Email"
            type="text"
          />
        </div>
      </div>
      <div class="form-group">
        <div class="controls">
          <textarea
            class="form-control"
            cols="40"
            id="candidateMotivation"
            name="candidate_motivation"
            placeholder="Message"
            rows="6"
          ></textarea>
        </div>
      </div>
      <div class="text-center">
        <div class="form-group drop-cv">
          <p><b>Merci de joindre votre CV à votre candidature :</b></p>
          <input
            type="file"
            name="resume_attachement"
            style="margin-top: -10px;"
          />
        </div>
      </div>
      <button type="submit">Envoyer</button>
    </form>

    <script src="../lib/index.js"></script>
  </body>
</html>
